
/* Port library for Arduino
created by Ashutosh M Bhatt (+91-9998476150) - Gujarat (INDIA) 
ver 1.0 - on 25/11/2018
using this library one can send direct 16 bit data to any arduino board pins
configured combined as a 16-bit port
also one can get 16-bit input from these configured pins
just one has to select any 16 arduino pins to be combined as 16-bit port 
and it has to configure its data direction as input or output
data direction is 'O' for port as output and 'I' for port as input
*/
#include "IO_Port_16bit.h"
#include "Arduino.h"
/*
this is constructor. it will create object(s) of this class and thus it will create one or many 16-bit port(s) by
combining distinct arduino pins. one has to specify 16 different arduino pins to be combined as port along with 
data direction as input or output - means port works as either input or output. the last argument dir in this constructor
defines port works as input or output. if dir='O' means port work as output and if dir='I', port works as input
the same port can not work as input and output both simulteneously or even alternatively. also it indicates error if data 
direction is not selected  
*/
IO_Port_16bit::IO_Port_16bit(int pin1,int pin2,int pin3,int pin4,int pin5,int pin6,int pin7,int pin8,int pin9,int pin10,int pin11,int pin12,int pin13,int pin14,int pin15,int pin16,char dir)
  {
      pin_1 = pin1;
      pin_2 = pin2;
      pin_3 = pin3;
      pin_4 = pin4;
      pin_5 = pin5;
      pin_6 = pin6;
      pin_7 = pin7;
      pin_8 = pin8;
      pin_9 = pin9;
      pin_10 = pin10;
      pin_11 = pin11;
      pin_12 = pin12;
      pin_13 = pin13;
      pin_14 = pin14;
      pin_15 = pin15;
      pin_16 = pin16;
      if(dir=='O')
        {
          pinMode(pin1,OUTPUT);  
          pinMode(pin2,OUTPUT); 
          pinMode(pin3,OUTPUT); 
          pinMode(pin4,OUTPUT); 
          pinMode(pin5,OUTPUT); 
          pinMode(pin6,OUTPUT); 
          pinMode(pin7,OUTPUT); 
          pinMode(pin8,OUTPUT); 
          pinMode(pin9,OUTPUT);  
          pinMode(pin10,OUTPUT); 
          pinMode(pin11,OUTPUT); 
          pinMode(pin12,OUTPUT); 
          pinMode(pin13,OUTPUT); 
          pinMode(pin14,OUTPUT); 
          pinMode(pin15,OUTPUT); 
          pinMode(pin16,OUTPUT);   
        }      
      else if(dir=='I')
        {
           pinMode(pin1,INPUT);   
           pinMode(pin2,INPUT);  
           pinMode(pin3,INPUT);  
           pinMode(pin4,INPUT);  
           pinMode(pin5,INPUT);  
           pinMode(pin6,INPUT);  
           pinMode(pin7,INPUT);  
           pinMode(pin8,INPUT);   
           pinMode(pin9,INPUT);   
           pinMode(pin10,INPUT);  
           pinMode(pin11,INPUT);  
           pinMode(pin12,INPUT);  
           pinMode(pin13,INPUT);  
           pinMode(pin14,INPUT);  
           pinMode(pin15,INPUT);  
           pinMode(pin16,INPUT);       
        } 
      else
        Serial.println("Error! The data direction (Input/Output) for port is not selected");  
   }
/*
this is another constructor. it will create object(s) of this class and thus it will create one or many 8-bit port(s) by
combining distinct arduino pins. one has to specify 8 different arduino pins to be combined as port. but it does not 
specify the data direction as input or output. after creating port object using this constructor one has to set the port
direction using set_IO_direction function. so this constructor allows programmer to alter port data direction in run time
using this constructor, the same port can work as input or output alternatively (but not simulteneously)
*/
IO_Port_16bit::IO_Port_16bit(int pin1,int pin2,int pin3,int pin4,int pin5,int pin6,int pin7,int pin8,int pin9,int pin10,int pin11,int pin12,int pin13,int pin14,int pin15,int pin16)
  {
      pin_1 = pin1;
      pin_2 = pin2;
      pin_3 = pin3;
      pin_4 = pin4;
      pin_5 = pin5;
      pin_6 = pin6;
      pin_7 = pin7;
      pin_8 = pin8;  
      pin_9 = pin9;
      pin_10 = pin10;
      pin_11 = pin11;
      pin_12 = pin12;
      pin_13 = pin13;
      pin_14 = pin14;
      pin_15 = pin15;
      pin_16 = pin16;    
  }   
/* this function specifies the input/output direction of port. it has one character argument that can be 
'I' for port as input or 'O' for port as output. if data direction is not selected, it displays error on
serial monitor of arduino */
void IO_Port_16bit::set_IO_direction(char dir)
  {
     if(dir=='O')
        {
          pinMode(pin_1,OUTPUT);  
          pinMode(pin_2,OUTPUT); 
          pinMode(pin_3,OUTPUT); 
          pinMode(pin_4,OUTPUT); 
          pinMode(pin_5,OUTPUT); 
          pinMode(pin_6,OUTPUT); 
          pinMode(pin_7,OUTPUT); 
          pinMode(pin_8,OUTPUT); 
          pinMode(pin_9,OUTPUT);  
          pinMode(pin_10,OUTPUT); 
          pinMode(pin_11,OUTPUT); 
          pinMode(pin_12,OUTPUT); 
          pinMode(pin_13,OUTPUT); 
          pinMode(pin_14,OUTPUT); 
          pinMode(pin_15,OUTPUT); 
          pinMode(pin_16,OUTPUT);    
        }      
      else if(dir=='I')
        {
           pinMode(pin_1,INPUT);   
           pinMode(pin_2,INPUT);  
           pinMode(pin_3,INPUT);  
           pinMode(pin_4,INPUT);  
           pinMode(pin_5,INPUT);  
           pinMode(pin_6,INPUT);  
           pinMode(pin_7,INPUT);  
           pinMode(pin_8,INPUT); 
           pinMode(pin_9,INPUT);   
           pinMode(pin_10,INPUT);  
           pinMode(pin_11,INPUT);  
           pinMode(pin_12,INPUT);  
           pinMode(pin_13,INPUT);  
           pinMode(pin_14,INPUT);  
           pinMode(pin_15,INPUT);  
           pinMode(pin_16,INPUT);       
        } 
      else
        Serial.println("Error! The data direction (Input/Output) for port is not selected");  
  }                          
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
// this function sends 16 bit data to specified pins. just give int data (must be < 65535) as an argument that is directly given to 
//16 different pins. if data is >65535 it displays error on serial monitor of arduino
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 void IO_Port_16bit::send_16bit_data(unsigned int byt)
   {
      int d=0;
      int binary[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
      Serial.begin(9600);
      if (byt>65535) Serial.println("Error! You are trying to send data having value greater than 16-bit (>65535)");
      else
       {
          while(byt>0)
          {
            binary[d] = byt%2;
            byt = byt/2;
            d++; 
          }
          if(binary[0]==1) digitalWrite(pin_1,HIGH);
          else digitalWrite(pin_1,LOW);
          if(binary[1]==1) digitalWrite(pin_2,HIGH);
          else digitalWrite(pin_2,LOW);
          if(binary[2]==1) digitalWrite(pin_3,HIGH);
          else digitalWrite(pin_3,LOW);
          if(binary[3]==1) digitalWrite(pin_4,HIGH);
          else digitalWrite(pin_4,LOW);
          if(binary[4]==1) digitalWrite(pin_5,HIGH);
          else digitalWrite(pin_5,LOW);
          if(binary[5]==1) digitalWrite(pin_6,HIGH);
          else digitalWrite(pin_6,LOW);
          if(binary[6]==1) digitalWrite(pin_7,HIGH);
          else digitalWrite(pin_7,LOW);
          if(binary[7]==1) digitalWrite(pin_8,HIGH);
          else digitalWrite(pin_8,LOW);
          if(binary[8]==1) digitalWrite(pin_9,HIGH);
          else digitalWrite(pin_9,LOW);
          if(binary[9]==1) digitalWrite(pin_10,HIGH);
          else digitalWrite(pin_10,LOW);
          if(binary[10]==1) digitalWrite(pin_11,HIGH);
          else digitalWrite(pin_11,LOW);
          if(binary[11]==1) digitalWrite(pin_12,HIGH);
          else digitalWrite(pin_12,LOW);
          if(binary[12]==1) digitalWrite(pin_13,HIGH);
          else digitalWrite(pin_13,LOW);
          if(binary[13]==1) digitalWrite(pin_14,HIGH);
          else digitalWrite(pin_14,LOW);
          if(binary[14]==1) digitalWrite(pin_15,HIGH);
          else digitalWrite(pin_15,LOW);
          if(binary[15]==1) digitalWrite(pin_16,HIGH);
          else digitalWrite(pin_16,LOW);
       }  
  } 
  
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////    
// this function gets 16 bit data from specified pins. it returns 16-bit int data by reading status of 16 different pins  
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     
unsigned int IO_Port_16bit::get_16bit_data(void)
  {
      long byt;
      int bin[16];
      bin[0] = digitalRead(pin_1);
      bin[1] = digitalRead(pin_2);
      bin[2] = digitalRead(pin_3);
      bin[3] = digitalRead(pin_4);
      bin[4] = digitalRead(pin_5);
      bin[5] = digitalRead(pin_6);
      bin[6] = digitalRead(pin_7);
      bin[7] = digitalRead(pin_8);
      bin[8] = digitalRead(pin_9);
      bin[9] = digitalRead(pin_10);
      bin[10] = digitalRead(pin_11);
      bin[11] = digitalRead(pin_12);
      bin[12] = digitalRead(pin_13);
      bin[13] = digitalRead(pin_14);
      bin[14] = digitalRead(pin_15);
      bin[15] = digitalRead(pin_16);
      byt = 32768*bin[15]+16384*bin[14]+8192*bin[13]+4096*bin[12]+2048*bin[11]+1024*bin[10]+512*bin[9]+256*bin[8]+128*bin[7]+64*bin[6]+32*bin[5]+16*bin[4]+8*bin[3]+4*bin[2]+2*bin[1]+bin[0]; 
      return byt;
  }              
